// Vertex-Shader
$rein float3 vertexPos;
$rein float2 vertexTexKoords;
$rein float  vertexSegmentIndex;

// Vertex-Ausgaben an den FragmentShader
$raus float4 fragPos;
$raus float4 fragWeltPos;
$raus float2 fragTexKoords;
$raus float4 fragKamPos; // Position der Kamera relativ zum Vertex in Weltkoordinaten, W ist Tiefe von Kamera

// Globale Konstanten
uniform float4x4 WeltMatrix, SichtMatrix, ProjMatrix;
uniform float2 SegmentSichtbarFlags; // .x Flags, .y Abschneide-Hhe fr Editor

$main()
{
  float4 pos = float4( vertexPos, 1.0f);
  float4 weltpos = mul( WeltMatrix, pos);
  
  // In Sichtkoords umrechnen, dort eventuell entfalten
  float4 kampos = mul( SichtMatrix, weltpos);
//  kampos.xy += vertexDehnung.xy;
  fragPos = mul( ProjMatrix, kampos);
  fragWeltPos = float4( weltpos.xyz, kampos.z / 500.0f);
  fragKamPos.xyz = (1.0f/32.0f) * mul( transpose( (float3x3) SichtMatrix), -kampos.xyz - float3( SichtMatrix._14, SichtMatrix._24, SichtMatrix._34));
  fragKamPos.w = 1.0f/76.0f * kampos.z;

  fragTexKoords = vertexTexKoords;
}